Index: kernel/classes/webdav/ezwebdavcontentserver.php
===================================================================
--- kernel/classes/webdav/ezwebdavcontentserver.php	(revision 20056)
+++ kernel/classes/webdav/ezwebdavcontentserver.php	(working copy)
@@ -84,6 +84,24 @@
 
     /*!
       \reimp
+      Fetch the file from eZCluster if needed before send.
+    */
+    function outputSendDataToClient( $output, $headers_only = false )
+    {
+    	if ( $output["file"] )
+    	{
+    		$realPath = $output["file"];
+	        require_once( 'kernel/classes/ezclusterfilehandler.php' );
+	        $file = eZClusterFileHandler::instance( $realPath );
+	        $file->fetch();
+    	}
+    	$result = eZWebDAVServer::outputSendDataToClient($output,$headers_only);
+    	$file->deleteLocal();
+    	return $result;
+    }
+
+    /*!
+      \reimp
       Restricts the allowed methods to only the subset that this server supports.
     */
     function options( $target )
@@ -1453,9 +1471,10 @@
                 $entry['mimetype'] = $info['mime_type'];
 
             // Fill in information from the actual file if they are missing.
-            if ( !$entry['size'] and file_exists( $filePath ) )
+	        $file = eZClusterFileHandler::instance( $filePath );
+            if ( !$entry['size'] and $file->exists() )
             {
-                $entry["size"] = filesize( $filePath );
+                $entry["size"] = $file->size();
             }
             if ( !$entry['mimetype']  )
             {
@@ -1473,10 +1492,10 @@
                     $entry["name"] .= '.' . $suffix;
             }
 
-            if ( file_exists( $filePath ) )
+            if ( $file->exists() )
             {
-                $entry["ctime"] = filectime( $filePath );
-                $entry["mtime"] = filemtime( $filePath );
+                $entry["ctime"] = $file->mtime();
+                $entry["mtime"] = $file->mtime();
             }
         }
         else
Index: kernel/classes/clusterfilehandlers/dbbackends/mysql.php
===================================================================
--- kernel/classes/clusterfilehandlers/dbbackends/mysql.php	(revision 20056)
+++ kernel/classes/clusterfilehandlers/dbbackends/mysql.php	(working copy)
@@ -403,7 +403,10 @@
         }
 
         // create temporary file
-        $tmpFilePath = substr_replace( $filePath, getmypid().'tmp', strrpos( $filePath, '.' ), 0  );
+        if ( strrpos( $filePath, '.' ) > 0 )
+            $tmpFilePath = substr_replace( $filePath, getmypid().'tmp', strrpos( $filePath, '.' ), 0  );
+        else
+            $tmpFilePath = $filePath . '.' . getmypid().'tmp';
 //        $tmpFilePath = $filePath.getmypid().'tmp';
         $this->__mkdir_p( dirname( $tmpFilePath ) );
         if ( !( $fp = fopen( $tmpFilePath, 'wb' ) ) )
